diff --git a/game/client/src/main/java/net/minecraft/client/gui/worldsettings/ButtonComponent.java b/game/client/src/main/java/net/minecraft/client/gui/worldsettings/ButtonComponent.java
index daf0493d4..fd96114d7 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/worldsettings/ButtonComponent.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/worldsettings/ButtonComponent.java
@@ -3,16 +3,16 @@ package net.minecraft.client.gui.worldsettings;
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.gui.ButtonElement;
 import net.minecraft.client.gui.paged.PageComponent;
-import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.render.renderer.BlendFactor;
+import net.minecraft.client.render.renderer.GLRenderer;
+import net.minecraft.client.render.renderer.Shaders;
+import net.minecraft.client.render.renderer.State;
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import net.minecraft.client.render.window.CursorShape;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.sound.SoundCategory;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
-import org.lwjgl.opengl.GL11;
-
-import static org.lwjgl.opengl.GL11.*;
-import static org.lwjgl.opengl.GL11.GL_BLEND;
 
 public abstract class ButtonComponent
     implements PageComponent {
@@ -49,7 +49,7 @@ public abstract class ButtonComponent
             textColor = 0xFFFFFFA0;
         }
 
-        mc.font.render(Tessellator.instance, translated, x, y + (this.getHeight() / 2) - 4).setShadow().setColor(textColor).call();
+        mc.font.render(translated, x, y + (this.getHeight() / 2) - 4).setShadow().setColor(textColor).call();
         this.resetButton.enabled = !this.isDefault();
         this.renderButton(x, y, width - BUTTON_WIDTH, COMPONENT_SPACING, BUTTON_WIDTH, 20, relativeMouseX, relativeMouseY);
         final int stringWidth = mc.font.stringWidth(translated);
@@ -110,19 +110,19 @@ public abstract class ButtonComponent
     }
 
     protected void drawRect(final int minX, final int minY, final int maxX, final int maxY, final int argb) {
-        final Tessellator tessellator = Tessellator.instance;
-        GL11.glEnable(GL_BLEND);
-        GL11.glDisable(GL_TEXTURE_2D);
-        GL11.glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
+        GLRenderer.pushFrame();
+        GLRenderer.setShader(Shaders.COLOR);
+        GLRenderer.enableState(State.BLEND);
+        GLRenderer.setBlendFunc(BlendFactor.SRC_ALPHA, BlendFactor.ONE_MINUS_SRC_ALPHA);
+        final TessellatorGeneral tessellator = GLRenderer.getTessellator();
         tessellator.startDrawingQuads();
-        tessellator.setColorRGBA_I(argb & 0x00FFFFFF, argb >> 24 & 0xff);
+        tessellator.setColor2i(argb & 0x00FFFFFF, argb >> 24 & 0xff);
         tessellator.addVertex(minX, maxY, 0.0D);
         tessellator.addVertex(maxX, maxY, 0.0D);
         tessellator.addVertex(maxX, minY, 0.0D);
         tessellator.addVertex(minX, minY, 0.0D);
         tessellator.draw();
-        GL11.glEnable(GL_TEXTURE_2D);
-        GL11.glDisable(GL_BLEND);
+        GLRenderer.popFrame();
     }
 
 }
diff --git a/game/client/src/main/java/net/minecraft/client/option/GameSettings.java b/game/client/src/main/java/net/minecraft/client/option/GameSettings.java
index d7cf32df4..b0262b031 100644
--- a/game/client/src/main/java/net/minecraft/client/option/GameSettings.java
+++ b/game/client/src/main/java/net/minecraft/client/option/GameSettings.java
@@ -78,7 +78,7 @@ public class GameSettings {
 	public @NotNull OptionBoolean invertMouse = new OptionBoolean(this, "invertYMouse", false);
 	public @NotNull OptionBoolean rawMouseInput = new OptionBoolean(this, "rawMouseInput", false);
 	public @NotNull OptionBoolean viewBobbing = new OptionBoolean(this, "bobView", true);
-	public @NotNull OptionBoolean advancedOpenGL = new OptionBoolean(this, "advancedOpengl", false);
+//	public @NotNull OptionBoolean advancedOpenGL = new OptionBoolean(this, "advancedOpengl", false);
 	public @NotNull OptionRange fancyGraphics = new OptionRange(this, "fancyGraphics", 1, 2);
 	public @NotNull OptionBoolean treeShadows = new OptionBoolean(this, "treeShadows", true);
 	public @NotNull OptionBoolean connectedGlass = new OptionBoolean(this, "connectedGlass", false);
@@ -90,7 +90,7 @@ public class GameSettings {
 	public @NotNull OptionBoolean vignette = new OptionBoolean(this, "vignette", true);
 	public @NotNull OptionBoolean showPlayerList = new OptionBoolean(this, "showPlayerList", false);
 	public @NotNull OptionBoolean slimeParticles = new OptionBoolean(this, "slimeParticles", true);
-	public @NotNull OptionBoolean disableShaders = new OptionBoolean(this, "disableShaders", false);
+//	public @NotNull OptionBoolean disableShaders = new OptionBoolean(this, "disableShaders", false);
 	public @NotNull OptionString shaderOverride = new OptionString(this, "shaderOverride", "");
 	public @NotNull OptionBoolean autoHit = new OptionBoolean(this, "autoHit", true);
 	public @NotNull OptionBoolean easyBridge = new OptionBoolean(this, "easyBridge", true);
@@ -123,7 +123,7 @@ public class GameSettings {
 	public @NotNull OptionRange renderDistance = new OptionRange(this, "renderDistance", 12, 2, 32);
 	public @NotNull OptionBoolean enableVsync = new OptionBoolean(this, "enableVsync", false);
 	public @NotNull OptionEnum<ChatVisibility> chatVisibility = new OptionEnum<>(this, "chatVisibility", ChatVisibility.class, ChatVisibility.SHOW_ALL);
-	public @NotNull OptionRange customFpsLimit = new OptionRange(this,"customFpsLimit",0,241);
+	public @NotNull OptionRange customFpsLimit = new OptionRange(this,"customFpsLimit",165,301);
 	public @NotNull OptionInteger guiScale = new OptionInteger(this, "guiScale", 0);
 	public @NotNull OptionInteger overlayMode = new OptionInteger(this, "overlayMode", 0);
 	public @NotNull OptionInteger rotationOverlayMode = new OptionInteger(this, "rotationOverlayMode", 0);
@@ -143,7 +143,7 @@ public class GameSettings {
 	public @NotNull OptionEnum<DescriptionPromptEnum> itemDescriptions = new OptionEnum<>(this, "itemDescriptions", DescriptionPromptEnum.class, DescriptionPromptEnum.PROMPT);
 	public @NotNull OptionBoolean turnWithVehicle = new OptionBoolean(this, "turnWithVehicle", true);
 	public @NotNull OptionBoolean disableCrashHandler = new OptionBoolean(this, "disableCrashHandler", false);
-	public @NotNull OptionBoolean enableMultiDrawRendering = new OptionBoolean(this, "enableMultiDrawRendering", true);
+//	public @NotNull OptionBoolean enableMultiDrawRendering = new OptionBoolean(this, "enableMultiDrawRendering", true);
 	public @NotNull OptionEnum<SelectedProvider> enableThreadedChunkProvider = new OptionEnum<>(this, "enableThreadedChunkProvider", SelectedProvider.class, SelectedProvider.THREADED);
 	public @NotNull OptionBoolean musicToasts = new OptionBoolean(this, "musicToasts", true);
 	public @NotNull OptionEnum<MusicFrequency> musicFrequency = new OptionEnum<>(this, "musicFrequency", MusicFrequency.class, MusicFrequency.DEFAULT);
@@ -405,7 +405,7 @@ public class GameSettings {
 		}
 		if(option == customFpsLimit){
 			int value = customFpsLimit.value;
-			int maxValue = 240;
+			int maxValue = 300;
 			if (enableVsync.value){
 				return String.valueOf(mc.gameWindow.getFrequency());
 			}
@@ -505,7 +505,7 @@ public class GameSettings {
 		if(option == fancyGraphics) mc.renderGlobal.allChanged();
 		if(option == ambientOcclusion) mc.renderGlobal.allChanged();
 		if(option == connectedGlass) mc.renderGlobal.allChanged();
-		if(option == advancedOpenGL) mc.renderGlobal.allChanged();
+//		if(option == advancedOpenGL) mc.renderGlobal.allChanged();
 		if(option == biomeWater) {
 			mc.renderGlobal.allChanged();
 			mc.textureManager.updateDynamicTextures(false);
@@ -548,11 +548,6 @@ public class GameSettings {
 				mc.currentScreen.opened(mc.resolution.getScaledWidthScreenCoords(), mc.resolution.getScaledHeightScreenCoords());
 			}
 		}
-		if(option == lightmapStyle) {
-			if (mc.renderGlobal != null) {
-				mc.renderGlobal.allChanged();
-			}
-		}
 		if(option == customLightmap) {
 			mc.worldRenderer.lightmapHelper.setup();
 		}
diff --git a/game/client/src/main/java/net/minecraft/client/option/OptionFloat.java b/game/client/src/main/java/net/minecraft/client/option/OptionFloat.java
index 61be56932..20b5cde37 100644
--- a/game/client/src/main/java/net/minecraft/client/option/OptionFloat.java
+++ b/game/client/src/main/java/net/minecraft/client/option/OptionFloat.java
@@ -7,9 +7,10 @@ public class OptionFloat extends Option<Float>{
 	public OptionFloat(GameSettings gameSettings, String name, float value) {
 		super(gameSettings, name, value);
 	}
-	
+
+
 	public float get() {
-		return value;
+		return this.value;
 	}
 	
 	public boolean isFloat() {
diff --git a/game/client/src/main/java/net/minecraft/client/option/OptionRange.java b/game/client/src/main/java/net/minecraft/client/option/OptionRange.java
index aeb1244b9..e4f3a3299 100644
--- a/game/client/src/main/java/net/minecraft/client/option/OptionRange.java
+++ b/game/client/src/main/java/net/minecraft/client/option/OptionRange.java
@@ -7,13 +7,13 @@ public class OptionRange extends OptionToggleable<Integer> {
 	public final int lowest;
     public OptionRange(GameSettings gameSettings, String name, int defaultValue, int values) {
         super(gameSettings, name, defaultValue, getValueArray(values));
-		highest = this.values[this.values.length - 1];
-		lowest = this.values[0];
+        this.highest = this.values[this.values.length - 1];
+        this.lowest = this.values[0];
     }
 	public OptionRange(GameSettings gameSettings, String name, int defaultValue, int lowest, int highest) {
 		super(gameSettings, name, defaultValue, getValueArray(lowest, highest));
-		this.highest = this.values[this.values.length - 1];
-		this.lowest = this.values[0];
+		this.highest = highest;
+		this.lowest = lowest;
 	}
 
 	@Override
diff --git a/game/client/src/main/java/net/minecraft/client/option/enums/LightmapStyle.java b/game/client/src/main/java/net/minecraft/client/option/enums/LightmapStyle.java
index 2126ba431..0013af6d8 100644
--- a/game/client/src/main/java/net/minecraft/client/option/enums/LightmapStyle.java
+++ b/game/client/src/main/java/net/minecraft/client/option/enums/LightmapStyle.java
@@ -3,7 +3,7 @@ package net.minecraft.client.option.enums;
 public enum LightmapStyle {
     GRAY("options.lightmapStyle.gray"),
     COLORIZED("options.lightmapStyle.colorized"),
-    DISABLED("options.lightmapStyle.disabled");
+    /*DISABLED("options.lightmapStyle.disabled")*/;
 
     private final String translationKey;
 
diff --git a/game/client/src/main/java/net/minecraft/client/render/EntityRenderDispatcher.java b/game/client/src/main/java/net/minecraft/client/render/EntityRendererDispatcher.java
similarity index 86%
rename from game/client/src/main/java/net/minecraft/client/render/EntityRenderDispatcher.java
rename to game/client/src/main/java/net/minecraft/client/render/EntityRendererDispatcher.java
index b716ba3cb..3ac8e1ae0 100644
--- a/game/client/src/main/java/net/minecraft/client/render/EntityRenderDispatcher.java
+++ b/game/client/src/main/java/net/minecraft/client/render/EntityRendererDispatcher.java
@@ -6,6 +6,7 @@ import java.util.Map;
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.render.entity.*;
 import net.minecraft.client.render.font.FontRenderer;
+import net.minecraft.client.render.renderer.GLRenderer;
 import net.minecraft.client.render.texturepack.TexturePackList;
 import net.minecraft.core.entity.EntityItem;
 import net.minecraft.core.entity.EntityLightning;
@@ -22,11 +23,9 @@ import net.minecraft.core.item.Items;
 import net.minecraft.core.world.World;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
-import org.lwjgl.opengl.GL11;
 import net.minecraft.client.option.GameSettings;
 import net.minecraft.client.render.camera.ICamera;
-import net.minecraft.client.render.tessellator.Tessellator;
-import net.minecraft.core.Global;
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.EntityFishingBobber;
 import net.minecraft.core.entity.EntityFallingBlock;
@@ -36,9 +35,8 @@ import net.minecraft.core.entity.projectile.ProjectileArrow;
 import net.minecraft.core.entity.projectile.ProjectilePebble;
 import net.minecraft.core.entity.vehicle.EntityMinecart;
 
-public final class EntityRenderDispatcher
-{
-    public static final @NotNull EntityRenderDispatcher instance = new EntityRenderDispatcher();
+public final class EntityRendererDispatcher {
+    public static final @NotNull EntityRendererDispatcher instance = new EntityRendererDispatcher();
     public static double renderPosX = 0;
     public static double renderPosY = 0;
     public static double renderPosZ = 0;
@@ -56,7 +54,7 @@ public final class EntityRenderDispatcher
     public double viewLerpPosY = 0;
     public double viewLerpPosZ = 0;
 
-    private EntityRenderDispatcher() {
+    private EntityRendererDispatcher() {
         final Minecraft mc = Minecraft.getMinecraft();
         this.textureManager = mc.textureManager;
         this.packList = mc.texturePackList;
@@ -117,7 +115,7 @@ public final class EntityRenderDispatcher
     @SuppressWarnings("unchecked") // trust me this is safe, Notch did it first
     public <T extends Entity> EntityRenderer<T> getRenderer(final @NotNull Class<T> e) {
         EntityRenderer<? extends Entity> r = this.renderers.get(e);
-        if(r == null && e != Entity.class) {
+        if (r == null && e != Entity.class) {
             r = getRenderer((Class<? extends Entity>) e.getSuperclass());
             this.renderers.put(e, r);
         }
@@ -129,9 +127,8 @@ public final class EntityRenderDispatcher
         return (EntityRenderer<T>) getRenderer(entity.getClass());
     }
 
-    public void cacheActiveRenderInfo(final @NotNull World world, final @NotNull ICamera camera, final float partialTick)
-    {
-        if(this.world != world) {
+    public void cacheActiveRenderInfo(final @NotNull World world, final @NotNull ICamera camera, final float partialTick) {
+        if (this.world != world) {
             for (final @Nullable EntityRenderer<?> renderer : this.renderers.values()) {
                 if (renderer == null) continue;
                 renderer.onWorldChanged(world);
@@ -146,40 +143,28 @@ public final class EntityRenderDispatcher
         this.viewLerpPosZ = camera.getZ(partialTick);
     }
 
-    public <T extends Entity> void renderEntity(final Tessellator tessellator, final T entity, final float partialTick) {
-        final double lerpPosX = entity.xo + (entity.x - entity.xo) * (double)partialTick;
-        final double lerpPosY = entity.yo + (entity.y - entity.yo) * (double)partialTick;
-        final double lerpPosZ = entity.zo + (entity.z - entity.zo) * (double)partialTick;
+    public <T extends Entity> void renderEntity(final TessellatorGeneral tessellator, final T entity, final float partialTick) {
+        final double lerpPosX = entity.xo + (entity.x - entity.xo) * (double) partialTick;
+        final double lerpPosY = entity.yo + (entity.y - entity.yo) * (double) partialTick;
+        final double lerpPosZ = entity.zo + (entity.z - entity.zo) * (double) partialTick;
         final float lerpYaw = entity.yRotO + (entity.yRot - entity.yRotO) * partialTick;
-        float brightness;
-
-        if(LightmapHelper.isLightmapEnabled()) {
-        	brightness = 1.0f;
-
-        	LightmapHelper.setLightmapCoord(entity.getLightmap(partialTick));
-        } else if(Global.accessor.isFullbrightEnabled()) {
-        	brightness = 1.0f;
-        } else {
-        	brightness = entity.getBrightness(partialTick);
-        }
-
-        if (Global.accessor.isFullbrightEnabled()) brightness = 1.0f;
-        GL11.glColor3f(brightness, brightness, brightness);
 
+        GLRenderer.setLightmapCoord1i(entity.getLightmap(partialTick));
+        GLRenderer.setColor3f(1f, 1f, 1f);
         renderEntityWithPosYaw(tessellator, entity, lerpPosX - renderPosX, lerpPosY - renderPosY, lerpPosZ - renderPosZ, lerpYaw, partialTick);
     }
 
-    public <T extends Entity> void renderEntityWithPosYaw(final @NotNull Tessellator tessellator, final @NotNull T entity, final double x, final double y, final double z, final float yaw, final float partialTick) {
+    public <T extends Entity> void renderEntityWithPosYaw(final @NotNull TessellatorGeneral tessellator, final @NotNull T entity, final double x, final double y, final double z, final float yaw, final float partialTick) {
         final EntityRenderer<T> renderer = getRenderer(entity);
-        if(renderer != null) {
+        if (renderer != null) {
             renderer.render(tessellator, entity, x, y, z, yaw, partialTick);
             renderer.postRender(tessellator, entity, x, y, z, yaw, partialTick);
         }
     }
 
-    public <T extends Entity> void renderEntityPreviewWithPosYaw(final @NotNull Tessellator tessellator, final @NotNull T entity, final double x, final double y, final double z, final float yaw, final float partialTick) {
+    public <T extends Entity> void renderEntityPreviewWithPosYaw(final @NotNull TessellatorGeneral tessellator, final @NotNull T entity, final double x, final double y, final double z, final float yaw, final float partialTick) {
         final EntityRenderer<T> renderer = getRenderer(entity);
-        if(renderer != null) {
+        if (renderer != null) {
             renderer.renderPreview(tessellator, entity, x, y, z, yaw, partialTick);
         }
     }
diff --git a/game/client/src/main/java/net/minecraft/client/render/FallbackRenderer.java b/game/client/src/main/java/net/minecraft/client/render/FallbackRenderer.java
index 3361df714..b10f9b691 100644
--- a/game/client/src/main/java/net/minecraft/client/render/FallbackRenderer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/FallbackRenderer.java
@@ -1,16 +1,13 @@
 package net.minecraft.client.render;
 
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.render.tessellator.ParticleTessellator;
-import net.minecraft.client.render.tessellator.Tessellator;
-import org.jetbrains.annotations.NotNull;
 
 public class FallbackRenderer implements Renderer {
 
 	public Minecraft mc;
 	
 	public FallbackRenderer(Minecraft minecraft) {
-		mc = minecraft;
+        this.mc = minecraft;
 	}
 
 	@Override
@@ -33,12 +30,7 @@ public class FallbackRenderer implements Renderer {
 
 	}
 
-	@Override
-	public @NotNull ParticleTessellator getParticleTessellator() {
-		return Tessellator.instance;
-	}
-
-	@Override
+    @Override
 	public void endRenderClouds(float partialTicks) {
 		
 	}
@@ -75,12 +67,12 @@ public class FallbackRenderer implements Renderer {
 
 	@Override
 	public int getRenderWidth() {
-		return mc.gameWindow.getWidthPixels();
+		return this.mc.gameWindow.getWidthPixels();
 	}
 
 	@Override
 	public int getRenderHeight() {
-		return mc.gameWindow.getHeightPixels();
+		return this.mc.gameWindow.getHeightPixels();
 	}
 
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/FogManager.java b/game/client/src/main/java/net/minecraft/client/render/FogManager.java
index 10ab8e7ab..803b2f89a 100644
--- a/game/client/src/main/java/net/minecraft/client/render/FogManager.java
+++ b/game/client/src/main/java/net/minecraft/client/render/FogManager.java
@@ -2,16 +2,13 @@ package net.minecraft.client.render;
 
 import static org.lwjgl.opengl.GL11.*;
 
-import java.nio.FloatBuffer;
-
 import net.minecraft.client.world.WorldClient;
 import net.minecraft.core.block.material.Materials;
 import net.minecraft.core.world.pos.TilePos;
 import org.jetbrains.annotations.NotNull;
 import org.joml.Vector3fc;
-import org.lwjgl.opengl.NVFogDistance;
+import org.joml.Vector4f;
 
-import net.minecraft.client.GLAllocation;
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.gui.ScreenPhotoMode;
 import net.minecraft.client.gui.modelviewer.ScreenModelViewer;
@@ -33,8 +30,6 @@ public class FogManager {
     public float fogBrightnessOld;
     public float fogBrightness;
 
-    private final @NotNull FloatBuffer fogColorBuffer = GLAllocation.createDirectFloatBuffer(16);
-
     public FogManager(@NotNull Minecraft mc) {
         this.mc = mc;
     }
@@ -54,57 +49,60 @@ public class FogManager {
         this.fogBrightness += (newBrightness - this.fogBrightness) * 0.1F;
     }
 
-    public void setupFog(int fogMode, float farPlaneDistance, float partialTick) {
-        glFogfv(GL_FOG_COLOR, buffer(this.fogRed, this.fogGreen, this.fogBlue, 0.5F));
-        glNormal3f(0.0F, -1F, 0.0F);
-        glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
-        if (!this.mc.gameSettings.fog.value && fogMode != FOG_MODE_SKY) {
-            glFogi(GL_FOG_MODE, GL_EXP);
-            glFogf(GL_FOG_DENSITY, 0.0F);
-            float maxFogDistance = this.mc.gameSettings.renderDistance.highest * 16;
-            glFogf(GL_FOG_START, maxFogDistance * 0.25F);
-            glFogf(GL_FOG_END, maxFogDistance);
-            glEnable(GL_COLOR_MATERIAL);
-            glColorMaterial(GL_FRONT, GL_AMBIENT);
-            return;
-        }
+    public @NotNull FogState setupFog(int fogMode, float farPlaneDistance, float partialTick, @NotNull FogState dest) {
+        dest.fogColor.set(this.fogRed, this.fogGreen, this.fogBlue, 0.5f);
 
+        byte cameraState;
         if (CameraUtil.isUnderLiquid(this.mc.activeCamera, this.mc.currentWorld, Materials.WATER, partialTick)) {
-            glFogi(GL_FOG_MODE, GL_EXP);
-            glFogf(GL_FOG_DENSITY, 0.1F);
+            cameraState = 1;
         } else if (CameraUtil.isUnderLiquid(this.mc.activeCamera, this.mc.currentWorld, Materials.LAVA, partialTick)) {
-            glFogi(GL_FOG_MODE, GL_EXP);
-            glFogf(GL_FOG_DENSITY, 2.0F);
+            cameraState = 2;
         } else {
-            float fogDistance = farPlaneDistance;
-            float maxFogDistance = this.mc.gameSettings.renderDistance.highest * 16;
-
-            float fogModifier = this.mc.currentWorld.getCurrentWeather() != null ? this.mc.currentWorld.getCurrentWeather().getFogDistanceMultiplier() : 1.0f;
-            fogModifier = (1.0f - ((1.0f - fogModifier) * this.mc.currentWorld.weatherManager.getWeatherIntensity() * this.mc.currentWorld.weatherManager.getWeatherPower()));
-
-            if (fogDistance > maxFogDistance * fogModifier) fogDistance = maxFogDistance * fogModifier;
+            cameraState = 0;
+        }
 
-            if (this.mc.currentScreen instanceof ScreenPhotoMode) {
-                fogDistance = farPlaneDistance * ((ScreenPhotoMode) this.mc.currentScreen).getFog(partialTick);
-            }
+        if (!this.mc.gameSettings.fog.value && fogMode != FOG_MODE_SKY && cameraState == 0) {
+            return dest.disable();
+        }
 
-            glFogi(GL_FOG_MODE, GL_LINEAR);
-            glFogf(GL_FOG_START, (fogDistance * 0.25F) * fogModifier);
-            glFogf(GL_FOG_END, fogDistance);
-            glFogf(GL_FOG_DENSITY, 1);
-            if (fogMode == FOG_MODE_SKY) {
-                glFogf(GL_FOG_START, 0.0F);
-                glFogf(GL_FOG_END, fogDistance * 0.8F);
+        switch (cameraState) {
+            case 1: {
+                dest.fogMode = FogState.Mode.EXP;
+                dest.fogDensity = 0.1F;
+                break;
             }
-            if (OpenGLHelper.enableSphericalFog) {
-                glFogi(NVFogDistance.GL_FOG_DISTANCE_MODE_NV, NVFogDistance.GL_EYE_RADIAL_NV);
+            case 2: {
+                dest.fogMode = FogState.Mode.EXP;
+                dest.fogDensity = 2.0f;
+                break;
             }
-            if (this.mc.currentWorld.dimension == Dimension.NETHER) {
-                glFogf(GL_FOG_START, 0.0F);
+            default: {
+                float fogDistance = farPlaneDistance;
+                float maxFogDistance = this.mc.gameSettings.renderDistance.highest * 16;
+
+                float fogModifier = this.mc.currentWorld.getCurrentWeather() != null ? this.mc.currentWorld.getCurrentWeather().getFogDistanceMultiplier() : 1.0f;
+                fogModifier = (1.0f - ((1.0f - fogModifier) * this.mc.currentWorld.weatherManager.getWeatherIntensity() * this.mc.currentWorld.weatherManager.getWeatherPower()));
+
+                if (fogDistance > maxFogDistance * fogModifier) fogDistance = maxFogDistance * fogModifier;
+
+                if (this.mc.currentScreen instanceof ScreenPhotoMode screenPhotoMode) {
+                    fogDistance = farPlaneDistance * screenPhotoMode.getFog(partialTick);
+                }
+
+                dest.fogMode = FogState.Mode.LINEAR;
+                dest.fogStart = (fogDistance * 0.25F) * fogModifier;
+                dest.fogEnd = fogDistance;
+                dest.fogDensity = 1F;
+                if (fogMode == FOG_MODE_SKY) {
+                    dest.fogStart = 0.0F;
+                    dest.fogEnd = fogDistance * 0.8F;
+                }
+                if (this.mc.currentWorld.dimension == Dimension.NETHER) {
+                    dest.fogStart = 0.0F;
+                }
             }
         }
-        glEnable(GL_COLOR_MATERIAL);
-        glColorMaterial(GL_FRONT, GL_AMBIENT);
+        return dest;
     }
 
     public void updateFogColor(float partialTick) {
@@ -174,10 +172,49 @@ public class FogManager {
         glClearColor(this.fogRed, this.fogGreen, this.fogBlue, 0.0F);
     }
 
-    private @NotNull FloatBuffer buffer(float r, float g, float b, float a) {
-        this.fogColorBuffer.clear();
-        this.fogColorBuffer.put(r).put(g).put(b).put(a);
-        this.fogColorBuffer.flip();
-        return this.fogColorBuffer;
+    public static class FogState {
+        public final @NotNull Vector4f fogColor = new Vector4f(0, 0, 0, 0);
+        public @NotNull Mode fogMode = Mode.EXP;
+        public float fogStart = 0f;
+        public float fogEnd = 1f;
+        public float fogDensity = 1f;
+
+        public FogState() {
+            reset();
+        }
+
+        public @NotNull FogState reset() {
+            this.fogColor.set(0, 0, 0, 0);
+            this.fogMode = Mode.EXP;
+            this.fogStart = 0f;
+            this.fogEnd = 1f;
+            this.fogDensity = 1f;
+            return this;
+        }
+
+        public @NotNull FogState disable() {
+            this.fogMode = FogState.Mode.EXP;
+            this.fogDensity = 0.0F;
+            float maxFogDistance = Minecraft.getMinecraft().gameSettings.renderDistance.highest * 16;
+            this.fogStart = maxFogDistance * 0.25f;
+            this.fogEnd = maxFogDistance;
+            return this;
+        }
+
+        public @NotNull FogState copy() {
+            FogState newState = new FogState();
+            newState.fogColor.set(this.fogColor);
+            newState.fogMode = this.fogMode;
+            newState.fogStart = this.fogStart;
+            newState.fogEnd = this.fogEnd;
+            newState.fogDensity = this.fogDensity;
+            return newState;
+        }
+
+        public enum Mode {
+            LINEAR,
+            EXP,
+            EXP2
+        }
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/Framebuffer.java b/game/client/src/main/java/net/minecraft/client/render/FrameBuffer.java
similarity index 96%
rename from game/client/src/main/java/net/minecraft/client/render/Framebuffer.java
rename to game/client/src/main/java/net/minecraft/client/render/FrameBuffer.java
index 597e1ea88..bdfdae08f 100644
--- a/game/client/src/main/java/net/minecraft/client/render/Framebuffer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/FrameBuffer.java
@@ -2,7 +2,7 @@ package net.minecraft.client.render;
 
 import static org.lwjgl.opengl.ARBFramebufferObject.*;
 
-public class Framebuffer {
+public class FrameBuffer {
 	
 	private int id;
 	
